function dashboard_widget (instance, widget) {
    "use strict";

    var widgets = widget;
    var InstalledModule = 0;
    

    widget.DashboardWidget = instance.Widget.extend({
        template: 'DashboardTmpl',
        widgets: [
            {
                title: 'Clientes',
                name: 'CustomerCounterWidget'
            }
        ],

        grid: {},
        start: function () {
            this.$el.find('.grid-stack.dashboard').gridstack({
                animate: true,
            });
            this.grid = this.$el.find('.grid-stack.dashboard').data('gridstack');
            this.renderWidgets();
        },
        renderWidgets: function () { 
            var self = this; 
            var wExpiredAccount = new widgets.ExpiredAccountCountersWidget(self);          
            wExpiredAccount.fecthIrModuleModule().then(function(modules){
                return modules;
            }).then(function(modules){
                if(modules.length == 0){
                    //Ranking de Ventas de Producto por Mes
                    var wRankingProduct = new widgets.RankingSalesProductWidget(self);
                    wRankingProduct.renderElement();
                    wRankingProduct.start();
                    self.grid.addWidget(wRankingProduct.$el, 0, 0, wRankingProduct.size.width,  wRankingProduct.size.height, true);
                    //Ranking de clientes que mas compra
                    var wRankingPartner = new widgets.RankingSalesPartnerWidget(self);
                    wRankingPartner.renderElement();
                    wRankingPartner.start();
                    self.grid.addWidget(wRankingPartner.$el, 0, 0, wRankingPartner.size.width,  wRankingPartner.size.height, true);
                }else{
                    //Invoice History
                    var wInvoiceHistory = new widgets.InvoiceHistoryWidget(self);
                    wInvoiceHistory.renderElement();
                    wInvoiceHistory.start();
                    self.grid.addWidget(wInvoiceHistory.$el, 0, 0, wInvoiceHistory.size.width,  wInvoiceHistory.size.height, true);
                    
                    //Ranking pos orders Salesman
                    var wRankingPosOrderSalesman = new widgets.RankingPosOrdersSalesmanWidget(self);
                    wRankingPosOrderSalesman.renderElement();
                    wRankingPosOrderSalesman.start();
                    self.grid.addWidget(wRankingPosOrderSalesman.$el, 0, 0, wRankingPosOrderSalesman.size.width,  wRankingPosOrderSalesman.size.height, true);

                    // Ranking de clientes
                    var wRankingPosOrderPartner = new widgets.RankingPosOrdersPartnerWidget(self);
                    wRankingPosOrderPartner.renderElement();
                    wRankingPosOrderPartner.start();
                    self.grid.addWidget(wRankingPosOrderPartner.$el, 0, 0, wRankingPosOrderPartner.size.width,  wRankingPosOrderPartner.size.height, true);
                    
                    //Ranking de Ventas de Producto por Mes - Point Of Sale
                    var wRankingPosOrderProduct = new widgets.RankingPosOrdersProductWidget(self);
                    wRankingPosOrderProduct.renderElement();
                    wRankingPosOrderProduct.start();
                    self.grid.addWidget(wRankingPosOrderProduct.$el, 0, 0, wRankingPosOrderProduct.size.width,  wRankingPosOrderProduct.size.height, true);                    
                }
            }); 
        }
    });
}
