function invoice_history (widget) {
    "use strict";

    var model = openerp;

    widget.InvoiceHistoryWidget = widget.Base.extend({
        template: 'InvoiceHistory',
        data: [],
        countPosOrder: [],
        resPartner: [],
        modelId: [],

        events: {
            // 'click canvas': 'showCustomers'
        },
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial:function() {
            var self = this;
            self.$el.block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            self.$el.find('.widget-content.widget-loading').css('display','flex');

            self.fecthAccountInvoice().then(function (AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchGetModelId();
            }).then(function(modelId) {
                self.modelId = modelId;
                return self.BuildChart();
            });
        },

        // getModelId
        fetchGetModelId: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');

            this.alive(getObtjectReference('base', 'view_partner_form')).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Obtener Pedidos
        fecthAccountInvoice: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','date_invoice','partner_id','amount_total','number','type'];
            var domain = [['state','in',['paid','open']]];
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        // Obtener facturas por cada proveedores
        getInAccountInvoice:function(mes) {
            var self = this;
            if (mes < 10){
                var fecha = moment().format('YYYY')+'-'+'0'+mes;    
            }else{
                var fecha = moment().format('YYYY')+'-'+mes;    
            }
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return moment(inv.date_invoice).format('YYYY-MM') === fecha & inv.type === 'in_invoice';
            }));
        },

        // Obtener facturas de clientes
        getOutAccountInvoice:function(mes) {
            var self = this;
            if (mes < 10){
                var fecha = moment().format('YYYY')+'-'+'0'+mes;    
            }else{
                var fecha = moment().format('YYYY')+'-'+mes;    
            }
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return moment(inv.date_invoice).format('YYYY-MM') === fecha & inv.type === 'out_invoice';
            }));
        },
        
        // Generar el Ranking
        BuildChart: function() {
            var self = this;
            var invoices;
            var mes = 0;
            var dataIn = [];
            var dataOut = [];

            for (var i = 1; i <= 12; i++) {
                invoices = self.getInAccountInvoice(i);
                var total = _.reduce(_.map(invoices,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);
                dataIn.push({
                    amount_total: accounting.formatNumber(total,0,".",","),
                })
            }
            
            for (var i = 1; i <= 12; i++) {
                invoices = self.getOutAccountInvoice(i);
                var total = _.reduce(_.map(invoices,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);
                dataOut.push({
                    amount_total: accounting.formatNumber(total,0,".",","),
                })
            }

            // self.data = data;
            self.$el.unblock();
            self.$el.find('.widget-content.widget-loading').css('display','none');
            self.$el.find('.widget-title').find('span').text("Historico de Facturas");
            self.fetchChart(dataIn, dataOut);
        },

        // Generar Grafico
        fetchChart: function (dataIn,dataOut) {
            var self = this;
            var label = ['Enero', 'Febrero', 'Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'];
            var bodyIn = [];
            var bodyOut = [];
            var item;
            var rank = 12;

            // InInvoice
            if (dataIn.length < rank && dataIn.length > 0){
                rank= ranking.length;
            }
            for (var i = 0; i < rank; i++) {
                if (dataIn[i]) {
                    item = dataIn[i];
                }
                if (dataIn.length === 0) {
                    item = {};
                    item.amount_total = 0;
                }
                bodyIn.push(item.amount_total);
            }


            // OutInvoice
            if (dataOut.length < rank && dataOut.length > 0){
                rank= ranking.length;
            }
            for (var i = 0; i < rank; i++) {
                if (dataOut[i]) {
                    item = dataOut[i];
                }
                if (dataOut.length === 0) {
                    item = {};
                    item.amount_total = 0;
                }
                bodyOut.push(item.amount_total);
            } 

            // Global method for setting Y axis number format.
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                type: 'line',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: 'Facturas de clientes  ',
                            data: bodyOut,
                            backgroundColor: '#e3f2fd',
                            borderColor: '#64b5f6',
                            borderWidth: 2,
                            fill: false,
                        },
                        {
                            label: 'Facturas de proveedor  ',                            
                            data: bodyIn,
                            backgroundColor: '#c8e6c9',
                            borderColor: '#66bb6a',
                            borderWidth: 2,
                            fill: false,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: true,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                }
            });
        },
    });
}
