function pos_order_today_counters(widget) {
    "use strict";

    var model = openerp;

    widget.PosOrderTodayCountersWidget = widget.Base.extend({
        template: 'PosOrderTodayCounters',
        irModelData: [],
        accountInvoice: [],

        events: {
            'click a': 'showCustomers',
            'click h2': 'showCustomers',
        },
        init: function (parent) {
            this._super(parent, {
                width : 3,
                height: 2
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial: function() {
            var self = this;
            self.$el.find('#morosidad').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.widget-content.widget-loading').css('display','flex');

            self.fetchPosOrder().then(function (PosOrder) {
                return PosOrder;
            }).then(function (PosOrder) {
                self.PosOrder=PosOrder;
                return self.fetchGetModelId();
            }).then(function(irModelData) {
                self.irModelData=irModelData;
                return self.fetchReducePosOrder(self.PosOrder);
            });
        },
        // getModelId
        fetchGetModelId: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');

            getObtjectReference('point_of_sale', 'view_pos_pos_form').then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Invoice
        fetchPosOrder: function() {
            var self = this;
            var defer = $.Deferred();
            var hoy = moment().format('YYYY-MM-DD h:mm:ss');
            // console.log(hoy)
            var fields = ['id', 'name','date_order'];
            var domain = [['state', 'in', ['paid','done','invoiced']],['date_order', '>=', hoy]];
            var PosOrder = new model.web.Model('pos.order');

            PosOrder.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchReducePosOrder: function (PosOrder) {
            var self = this;
            var fecha = new Date();
            var cat = 0;

            if (PosOrder.length > 0) {
                cat = PosOrder.length;
            }

            self.$el.find('.widget-content.widget-loading').css('display','none');
            self.$el.find('.widget-content').find('a').text(accounting.formatNumber(cat, ".", ","));
            self.$el.find('#morosidad').unblock();
        },
        showCustomers: function (e) {
            var self = this;
            if (self.PosOrder.length === 0) {
                model.web.notification.do_warn("Atención","Sin datos");
                return
            }
            var hoy = moment().format('YYYY-MM-DD 00:00:00');
            this.do_action({
                name: "Pedidos realizados hoy",
                type: 'ir.actions.act_window',
                res_model: "pos.order",
                views: [[false, 'list'],[self.irModelData[1],'form']],
                target: 'current',
                domain: [['state', 'in', ['paid','done','invoiced']],['date_order', '>=', hoy]],
                context: {},
            });
        }
    });
}
